
' ta (stupnice) ke QRP transceiveru s obvodem ATtiny2313
' VERZE 2.1 , OK1HDU

' Pedpokld se pouit peddliky dvma. ta t 2x del dobu - v podprogramu Pridej0 je zvena hodnota z 10ti na 20.
'
' krystal  22,1184 Mhz
' display - inteligentn LCD 2x8 znak (nap: GDM0802A )
'
' pipojenm pinu 11 na zem a resetem navolen reimu nastaven MF
' pin 8 krokovn MF kmitotu dol (po 1 khz)
' pin 7 krokovn MF kmitotu nahoru (po 1 khz)
' pin 6 uloen nastavenho MF kmitotu do intern EEPROM (indikuje slovem "done" po dobu 4 sekund)
'
'
'


$regfile = "ATtiny2313.dat"
$crystal = 22118400
$lib "lcd4.lbx"

Config Lcd = 16 * 2                                         'Program nezna displej 8*2 ale s konfiguraci 16*2 funguje
Config Lcdmode = Port

 Dim P As Byte                                              ' pridanch 8 bit ke Counteru1 (zvysuje se o 1 pri preteceni)
 Dim K As Byte                                              ' kolikrat doslo k preteceni behem jednoho mereni (0,1 sekundy)
 Dim X As Word                                              ' okamit hodnota Counteru1 po skonen hradlovn
 Dim A As Word                                              ' ta setin sekundy (mus probhnout desetkrt pro hradlovn)

 Dim Frq As Long                                            ' pomocn promnn pro vpoet kmitotu
 Dim F As String * 8                                        ' pomocn promnn pro zobrazen kmitotu
 Dim Mf As Eram Long                                        ' Hodnota Mezifrekvence Uloen V Eeprom
 Dim Mff As Long                                            ' pomocn promnn pi nastavovn mezifrekvence
 Dim Mfk As Long

Config Timer0 = Timer , Prescale = 1024                     ' peddlika 1024 pro 8mi bitov Timer0
Config Timer1 = Counter , Prescale = 1 , Edge = Falling , Noise Cancel = 1       ' nastaven Timer1 jako ta


Rem nastaven pin portu D jako vstupnch a zapojen internch pullup rezistor

Config Pind.6 = Input
Set Portd.6
Config Pind.2 = Input
Set Portd.2
Config Pind.3 = Input
Set Portd.3
Config Pind.4 = Input
Set Portd.4

Rem pokud je po resetu PinD.6 pipojen na zem - skok do nastaven Mezifrekvence (podprogram "Nastav")
If Pind.6 = 0 Then
Goto Nastav
End If

Rem zobrazen verze SW.
Cls
Cursor Off
Upperline
Lcd "nasobi"
Lowerline
Lcd "dvema"
Wait 2


Rem povolen asovae Timer0, povolen peruen obecn, povolen peruen Overflow0 a Overflow1
Enable Timer0
Enable Interrupts
Enable Ovf0
Enable Ovf1
Start Timer0                                                ' Spusteni casovace Timer0


On Ovf0 Pridej0                                             ' pi peruen od peteen  asovae 0 odskok do podprogramu (celkem 10x za jedno men)
On Ovf1 Pridej1                                             ' pi peruen od peteen tae 1 odskok do podprogramu (pidv poslednch 8 bit tae)



Cls
Lowerline                                                   'pomocn texty na displej
Lcd "Qrp   cw"
Upperline
Cursor Off


Rem hlavn smyka vpotu a zobrazovn kmitotu
Do
    Locate 1 , 1
    Lcd "        "
    Locate 1 , 1
    Frq = K * 65536                                         'Vypocet kmitoctu
    Frq = Frq + X
    Frq = Frq + Mf                                          'Pricteni MF
    Frq = Abs(frq)
    F = Str(frq)                                            'Formatovani vysledku pro zobrazeni
    F = Left(f , 7)
    F = Format(f , " 0000.00")
    Lcd F                                                   'Zobrazeni
    Waitms 50
Loop



Rem podprogramy

Precti:                                                     'peten stavu tae1,
X = Timer1
K = P                                                       'vynulovn
Timer1 = 0
P = 0
Return

Pridej0:                                                    'generovani hradlovaciho signalu 10Hz
Incr A
If A = 20 Then
Gosub Precti
A = 0
End If
Tcnt0 = 40                                                  'prednastaveni hodnoty Timeru0
Return


Pridej1:                                                    'zven nejvyho du tae
Incr P
Return


Rem nastaven MF kmitotu po uzemn pinu D.6 a restartu
Rem slep vtev. Opust se restartem pi neuzemnm pinu D.6

Nastav:
Mff = Mf / 100                                              ' peten hodnoty MF z EEprom a zobrazen
Cls
Cursor Off
Locate 1 , 1
Lcd "MF"
Locate 2 , 1
Lcd Mff
Locate 2 , 6
Lcd "khz"


Do                                                          ' zatek smyky nastaven hodnoty MF

   Locate 2 , 1                                             ' uloen hodnoty MF do EEprom
   If Pind.2 = 0 Then
   Mfk = Mff * 100
   Mf = Mfk
   Lcd "done"
   Wait 4
   Locate 2 , 6
   Lcd "khz"
   End If

   If Pind.3 = 0 Then                                       ' zven hodnoty MF o 1khz
   Incr Mff
   Lcd Mff
   Waitms 100
   End If

   If Pind.4 = 0 Then                                       ' snen hodnoty MF o 1khz
   Decr Mff
   Lcd Mff
   Waitms 100
   End If
   Locate 2 , 1
   Lcd "     "
   Locate 2 , 1
   Lcd Mff
   Waitms 100
Loop

End                                                         'end program